
/*--------------------------Licensed under GNU General Public License---------------------

see header in aducprog.c or license in gpl.txt for details.
-----------------------------------------------------------------------------------------*/
/*pacfuncs.c*/
/*some funcs to deal with ADI's packet scheme*/
/*and intel hex files*/

#include <stdio.h>
#include <string.h>     //for bzero

#include "globdefs.h"
#include "pacfuncs.h"
#include "errhand.h"


byte bchecksum(char *data, int datalen)   /* data + checksum = 0 (8bit math.)*/

{
int counter;
byte acc;


acc=0;
for (counter=0;counter < datalen;counter++) acc += data[counter];

acc = ~acc;
acc += (byte)1;         //8 bit twos complement
return(acc);
}


//called as intelhex2data(&packtype, &bytecnt, &loadaddr, datapack, inlinebuf);

int intelhex2data(int *packtype, int *byteqty, int *loadaddr,
                        char *datapack, char *inlinebuf)
{
int bytecount, byteval;
int tempaddrval;
int checksum;
char tempstring[36];
byte acc;

acc = 0;

bzero(datapack, 16);            //wipe packet to nulls..
                                //really for my debugging.

if (inlinebuf[0] != ':') {
  *packtype = -1;
  *loadaddr = -1;
  return(-2);
}
memcpy(tempstring,inlinebuf + (size_t)1, 2);
tempstring[2]=0;
sscanf(tempstring,"%x",byteqty);
acc += *byteqty;


memcpy(tempstring,inlinebuf + (size_t)3,2);
tempstring[2]=0;
sscanf(tempstring,"%x",&tempaddrval);
acc += tempaddrval;

memcpy(tempstring,inlinebuf + (size_t)5,2);
tempstring[2]=0;
sscanf(tempstring,"%x",&tempaddrval);
acc += tempaddrval;                        //got to deal with each 2 digi hex number
                                           //for checksum
memcpy(tempstring,inlinebuf + (size_t)3,4);
tempstring[4]=0;
sscanf(tempstring,"%x",loadaddr);       //easier to just reread as 4digits.

memcpy(tempstring,inlinebuf + (size_t)7,2);
tempstring[2]=0;
sscanf(tempstring,"%x",packtype);
acc += *packtype;

for (bytecount=0;bytecount<*byteqty;bytecount++) {
  memcpy(tempstring,inlinebuf + (size_t)9 + (size_t)(2*bytecount),2);
  tempstring[2]=0;
  sscanf(tempstring, "%x", &byteval);
  acc += byteval;
  datapack[bytecount] = (char)byteval;
}

memcpy(tempstring,inlinebuf + (size_t)9 + (size_t)(2*bytecount),2);
tempstring[2]=0;
sscanf(tempstring,"%x", &checksum);


if (((acc + checksum) & 0xff) != 0)
{

  printf ("\nERROR on line %s: ",inlinebuf);
  printf ("\nacc is 0x%02x, checksum is 0x%02x\n",acc, checksum);
   return(-1);
}


return(0);

} //end intelhex2data

int data2ADprogpack(char *progpack, char *datapack,
                int page, int address, int byteqty, int datamemflag)
{
int packpos;


progpack[0] = 0x07; progpack[1] = 0x0E;
progpack[2] = (char)(byteqty+4);        //command char and addr considered as data
                                        //for byte count in packet
if (datamemflag == TRUE) die ("programming data mem not implemented yet");
//progpack[3] = 'E'
else {progpack[3] = 'W';}
progpack[4] =  (char)page;
progpack[5] = (char)(address>>8);
progpack[6] = (char)(address & 0xFF);

for (packpos=7;packpos < 7 + byteqty; packpos++)
  progpack[packpos] = datapack[packpos - 7];

progpack[packpos] = bchecksum((progpack + (size_t)2), byteqty + 5);


//add 5 cause commandbyte, qtybytes byte, and 3 addr bytes
//blegh
return(byteqty+8);
}                                










