

/*--------------------------Licensed under GNU General Public License---------------------

see header in aducprog.c or license in gpl.txt for details.
-----------------------------------------------------------------------------------------*/

/*userint.c*/
/*"main menu", also functions that interact with user via stdin,stdout*/

#define _GNU_SOURCE		/*needed for getline*/
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>		//for time
#include <sys/time.h>		//for hi res time
#include "errhand.h"            //for warn
#include "userint.h"		//for prototypes
#include "globdefs.h"		/*for logfile*/


extern Status status;



int chomp(char *string)		/*goes thru string, replaces terminating newline with null*/
{				/*also will knock off a terminating carriage return*/
char *last, *this;
int length;
length = (strlen(string))+1;


for(last = this = string; 1 ; this++) {	/*step thru string*/
   if (*this == '\0' && (*last == '\n' || *last == '\r')) {
       *last = '\0';
       return(0);			/*a newline was chomped*/
   }
   (last = this);
   if (*this == '\0') return(1);		/*a newline wasn't chomped*/	
}   /*end for*/
}   /*end chomp*/

void cutcrap(char *string)              //no protection against walking off the end of allocated
{                                       //memory... string MUST have a \n or this will seg fault or cause
while (*(string++) != '\n');            //a problem!
*string = '\0';
}


int strsubst(char *string)	/*substitution of newlines*/
{
char this,last;
char *copy;	/*copy is a copy of the string*/
char *copypos, *stringpos;
copy = (char *)malloc(strlen(string)+1);	/*get space for copy!*/
copypos = copy;
stringpos = string;
last = '\0';
while ((this = *stringpos++) != '\0')  {
   if (last == '\\' && this == '\\') {
      *(copypos - 1) = '\\';		/*qouted the slash*/
      this = ' ';			/*for \\n = '\','n'*/
   }
   else if (last == '\\' && this == 'n') *(copypos -1) = '\n';
   else *copypos++ = this;
   last = this;
}
*copypos = '\0';		/*got's to terminate the string*/
strcpy (string, copy);		/*put it back in its original place and free mem*/
free(copy);
return(0);
}


char *getdatetime()		//gets time, formats, gives string
{
static char timestring[24];	//string

time_t systime_space;
time_t *systime;
struct tm *heretime;		/*pointer to struct tm*/
systime = &systime_space;	/*point to room for time*/

if ((time(systime)) == (time_t)(-1)) warn ("call to time() fail in nicetime!");
					/*get the current time*/
					/*if time == (time_t)(-1) time not availiable*/
heretime = localtime(systime);		/*get the local time*/
strftime(timestring,24,"%Y-%m-%d %T",heretime); //2001-04-04--14:55:01
return(timestring);
}

char *getustime()			//gets us time, formats, gives string
{                                       //darn thing takes 3-4 us on 600Mhz PII!
static int hasrun=0;
static long firsttime_sec, firsttime_usec;
static char errval[] = "invalid time";
static char timestring[24];
long int elapsed,elapsed_sec,elapsed_usec;
struct timeval *now;
now = malloc(sizeof(struct timeval));
if (gettimeofday(now, NULL)) {
   warn("gettimeofday failed in getustime.");
   free(now);
   return(errval);
}
if (!hasrun) {
  hasrun=1;	//we've run now
  firsttime_sec = now->tv_sec;
  firsttime_usec = now->tv_usec;
  }
elapsed = (now->tv_sec - firsttime_sec)*1000000 + (now->tv_usec-firsttime_usec);
elapsed_sec = elapsed/1000000;
elapsed_usec = elapsed - elapsed_sec*1000000;
snprintf(timestring, 24, "%li.%06li",elapsed_sec,elapsed_usec);
free(now);
return(timestring);   //Yuck.  good thing computers are so fast now..
}

int getusonly()		//just get microseconds...
{
int usec;
struct timeval *now;
now = malloc(sizeof(struct timeval));		//yeesh.. isn't there just a memory location
if (gettimeofday(now, NULL)) {			//I could set a ptr to?
   warn("gettimeofday failed in getustime.");
   free(now);
   return(-1);
}
usec = now->tv_usec;
free(now);
return(usec);
}


char *byte2stringb(unsigned char in)		//converts single byte to "11100000"	
{                                               //type string
unsigned char holder = in;                      //returns pointer to static storage here
static char binstring[9]="";                    //can't call 2x in same printf and expect
int count;                                      //more than 1 ptr, so WATCHOUT!

for (count=0; count < 8; count++)
{
binstring[count] =  holder & 0x80 ? '1' : '0';
holder =  holder << 1;
}

binstring[count] = '\0'; //term the string
return binstring;
}

